Attribute VB_Name = "Mod2"
Option Explicit


    ' *******************************************************************************************************************
    ' *                                                                                                                                            *
    ' *                                       Calculate LRC checksum                                                                 *
    ' *                                                                                                                                             *
    ' *       The data is all XORed together and placed in the LSByte.  The 1's Compliment is placed       *
    ' *       in the MSByte.  When the two bytes are ANDed the result is zero                                       *
    ' *                                                                                                                                             *
    ' *  Input:  Hex string        e.g.  "0108001000E00"    (must be even no. of characters)               *
    ' *  Output: 16 bit LRC      e.g.  "F906"                                                                                         *
    ' *                                                                                                                                             *
    ' * J.A.Goulbourne,  Copyright Texas Instruments Ltd,  Jan 2002                                                   *
    ' ******************************************************************************************************************

Public Sub CheckLRC(sCmdString, sLRC)
         
        Dim LRC As Long
        Dim i As Integer
        Dim ByteVal As String
        Dim HNibble As Byte
        Dim LNibble As Byte
        Dim MSByte As String
        Dim LSByte As String
        Dim sTemp As String
                                                                                                          
        LRC = &H0&                                                                                              ' Start value
       
       ' ******* convert to decimal bytes **************
        For i = 1 To Len(sCmdString) Step 2                                                             ' Step thru characters
            If Mid$(sCmdString, i, 1) >= "A" And Mid$(sCmdString, i, 1) <= "F" Then     ' If A ~ F
               HNibble = (Asc(Mid$(sCmdString, i, 1)) - 55) * 16                                    '    convert high nibble to dec
            Else                                                                                                        ' Else if 0 ~ 9
                HNibble = (Asc(Mid$(sCmdString, i, 1)) - 48) * 16                                   '    convert high nibble to dec
            End If
            If Mid$(sCmdString, i + 1, 1) >= "A" And Mid$(sCmdString, i + 1, 1) <= "F" Then   ' If A ~ F
                LNibble = (Asc(Mid$(sCmdString, i + 1, 1)) - 55)                                     '   convert low nibble to dec
            Else                                                                                                        ' Else if 0 ~ 9
                LNibble = (Asc(Mid$(sCmdString, i + 1, 1)) - 48)                                      '    convert low nibble to dec
            End If
            ByteVal = (HNibble + LNibble)                                                                    ' reconstruct byte as dec
          
                            
                 ' *******  Perform XOR operation  *************
            LRC = LRC Xor ByteVal
        Next i
       
        sTemp = Hex(LRC)
        
        If Len(sTemp) = 1 Then
             LSByte = "0" & sTemp
        Else
             LSByte = sTemp
        End If
        
        MSByte = Hex(LRC Xor &HFF)
        
        If Len(MSByte) = 1 Then
            MSByte = "0" & MSByte
        End If
            
        sLRC = LSByte & MSByte
End Sub
